/*
$Header: /var/lib/cvsd/var/lib/cvsd/VulnApp/HigherOrLower.aspx.cs,v 1.2 2011/02/12 14:24:13 timb Exp $

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.
* Neither the name of the Nth Dimension nor the names of its contributors may
be used to endorse or promote products derived from this software without
specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

(c) Tim Brown, 2011
<mailto:timb@nth-dimension.org.uk>
<http://www.nth-dimension.org.uk/> / <http://www.machine.org.uk/>
*/

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace VulnApp
{
	/// <summary>
	/// Summary description for HigherOrLower.
	/// </summary>
	public class HigherOrLower : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label HigherOrLowerLabel;
		protected System.Web.UI.WebControls.Label NumberLabel;
		protected System.Web.UI.WebControls.Button HigherButton;
		protected System.Web.UI.WebControls.Button LowerButton;
		protected System.Web.UI.WebControls.HyperLink BackToMainHyperLink;
		protected System.Web.UI.WebControls.Label ScoreLabel;
		protected System.Data.SqlClient.SqlConnection SQLConnection;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Int16 ID = -1;
			if (Request.Cookies["user"] != null)
			{
				if (Request.Cookies["user"]["id"] != null)
				{
					ID = Int16.Parse(Request.Cookies["user"]["id"]);
				}
			}
			try
			{
				this.SQLConnection.Open();
				SqlCommand SQLCommand = new SqlCommand("SELECT * from users WHERE id=" + ID.ToString(), this.SQLConnection);
				SqlDataReader SQLDataReader = SQLCommand.ExecuteReader();
				if (SQLDataReader.HasRows)
				{
					if (Session["higherorlowerrandom"] == null)
					{
						Random HigherOrLowerRandom = new Random(ID);
						Session["higherorlowerrandom"] = HigherOrLowerRandom;
						this.NumberLabel.Text = ((Random)Session["higherorlowerrandom"]).Next().ToString();
					}
					VulnServiceStub VulnService = new VulnServiceStub();
					this.ScoreLabel.Text = VulnService.GetScore(ID.ToString()) + " points";
				}
				else
				{
					ID = -1;
					Response.Cookies["user"]["id"] = ID.ToString();
					Response.Redirect("Default.aspx?returnurl=HigherOrLower.aspx&error=Please+log+in", true);
				}
				this.SQLConnection.Close();
			}
			catch (Exception AppException)
			{
				this.SQLConnection.Dispose();
				throw (AppException);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.SQLConnection = new System.Data.SqlClient.SqlConnection();
			this.HigherButton.Click += new System.EventHandler(this.HigherButton_Click);
			this.LowerButton.Click += new System.EventHandler(this.LowerButton_Click);
			// 
			// SQLConnection
			// 
			this.SQLConnection.ConnectionString = "workstation id=EREBOS;packet size=4096;user id=vulnapp;data source=localhost;pers" +
				"ist security info=True;initial catalog=vulndb;password=vulnapp;Max Pool Size=1000";
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void HigherButton_Click(object sender, System.EventArgs e)
		{
			Int16 ID = -1;
			if (Request.Cookies["user"] != null)
			{
				if (Request.Cookies["user"]["id"] != null)
				{
					ID = Int16.Parse(Request.Cookies["user"]["id"]);
				}
			}
			Int32 CurrentNumber = Int32.Parse(this.NumberLabel.Text);
			this.NumberLabel.Text = ((Random)Session["higherorlowerrandom"]).Next().ToString();
			try
			{
				this.SQLConnection.Open();
				SqlCommand SQLCommand = new SqlCommand("SELECT * from users WHERE id=" + ID.ToString(), this.SQLConnection);
				SqlDataReader SQLDataReader = SQLCommand.ExecuteReader();
				if (SQLDataReader.HasRows)
				{
					SQLDataReader.Read();
					Int64 CurrentScore = SQLDataReader.GetInt64(5);
					if (CurrentNumber < Int32.Parse(this.NumberLabel.Text))
					{
						this.SQLConnection.Close();
						this.SQLConnection.Open();
						SQLCommand = new SqlCommand("UPDATE users SET score=" + (CurrentScore + 100) + " WHERE id=" + ID.ToString(), this.SQLConnection);
						SQLCommand.ExecuteNonQuery();
						this.SQLConnection.Close();
					}
					else
					{
						this.SQLConnection.Close();
						this.SQLConnection.Open();
						SQLCommand = new SqlCommand("UPDATE users SET score=" + (CurrentScore - 100) + " WHERE id=" + ID.ToString(), this.SQLConnection);
						SQLCommand.ExecuteNonQuery();
						this.SQLConnection.Close();
					}
				}
				else
				{
					ID = -1;
					Response.Cookies["user"]["id"] = ID.ToString();
					Response.Redirect("Default.aspx?returnurl=HigherOrLower.aspx&error=Please+log+in", true);
				}
			}
			catch (Exception AppException)
			{
				this.SQLConnection.Dispose();
				throw (AppException);
			}
		}

		private void LowerButton_Click(object sender, System.EventArgs e)
		{
			Int16 ID = -1;
			if (Request.Cookies["user"] != null)
			{
				if (Request.Cookies["user"]["id"] != null)
				{
					ID = Int16.Parse(Request.Cookies["user"]["id"]);
				}
			}
			Int32 CurrentNumber = Int32.Parse(this.NumberLabel.Text);
			this.NumberLabel.Text = ((Random)Session["higherorlowerrandom"]).Next().ToString();
			this.SQLConnection.Open();
			SqlCommand SQLCommand = new SqlCommand("SELECT * from users WHERE id=" + ID.ToString(), this.SQLConnection);
			SqlDataReader SQLDataReader = SQLCommand.ExecuteReader();
			if (SQLDataReader.HasRows)
			{
				SQLDataReader.Read();
				Int64 CurrentScore = SQLDataReader.GetInt64(5);
				if (CurrentNumber > Int32.Parse(this.NumberLabel.Text))
				{
					this.SQLConnection.Close();
					this.SQLConnection.Open();
					SQLCommand = new SqlCommand("UPDATE users SET score=" + (CurrentScore + 100) + " WHERE id=" + ID.ToString(), this.SQLConnection);
					SQLCommand.ExecuteNonQuery();
					this.SQLConnection.Close();
				}
				else
				{
					this.SQLConnection.Close();
					this.SQLConnection.Open();
					SQLCommand = new SqlCommand("UPDATE users SET score=" + (CurrentScore - 100) + " WHERE id=" + ID.ToString(), this.SQLConnection);
					SQLCommand.ExecuteNonQuery();
					this.SQLConnection.Close();
				}
			}
			else
			{
				ID = -1;
				Response.Cookies["user"]["id"] = ID.ToString();
				Response.Redirect("Default.aspx", true);
			}
		}
	}
}
